freeslot("S_REPORT", "MT_REPORT", "S_AMOGUS", "SPR_AMOG", "SPR2_SUS_", "S_PLAY_SUSFACE", "S_LESUSAMOGUS")
freeslot("sfx_kill", "sfx_report", "sfx_meet", "sfx_vote", "sfx_eject", "sfx_textj")

for i = 1, 3
freeslot("sfx_ventg"..i)
end

local ventsound = {
sfx_ventg1, sfx_ventg2,
sfx_ventg3}

local REPORTCOOLDOWN = 40
local MAXKILLCOOLDOWN = 30

states[S_REPORT] = {
	sprite = SPR_PLAY,
	frame = SPR2_LIFE,
	tics = 2,
	nextstate = S_NULL
}

states[S_PLAY_SUSFACE] = {
	sprite = SPR_PLAY,
	frame = SPR2_SUS_,
	tics = 64,
	nextstate = S_PLAY_STND
}

states[S_AMOGUS] = {
	sprite = SPR_AMOG,
	frame = A,
	tics = 2,
	nextstate = S_AMOGUS
}

freeslot("SKINCOLOR_OUTLINE")

skincolors[SKINCOLOR_OUTLINE] = {
    name = "Outline",
    ramp = {36,36,36,36,36,36,36,36,36,36,36,36,36,36,36,36},
    invcolor = SKINCOLOR_RED,
    invshade = 0,
    chatcolor = V_REDMAP,
    accessible = false
}

local function CheckAndpass(mo, sec)
  for fof in sec.ffloors()
    if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
    if not (fof.flags & FF_SOLID) continue end -- Is it bustable?
    
    if mo.z + mo.height < fof.bottomheight continue end -- Are we too low?
    if mo.z > fof.topheight continue end -- Are we too high? 
	
	local check = P_SpawnMobj(mo.x, mo.y, fof.bottomheight, MT_THOK)
	check.flags2 = $|MF2_DONTDRAW
	
	if mo.player.cmd.buttons & BT_SPIN and not (check.eflags & MFE_TOUCHLAVA or check.eflags & 	MFE_GOOWATER or check.eflags & MFE_UNDERWATER)
	and mo.player.ventpass != false 
	and P_CheckPosition(check, mo.x*FRACUNIT, mo.y*FRACUNIT, fof.bottomheight) == true
		P_TeleportMove(mo, mo.x, mo.y, fof.bottomheight)
		mo.player.ventpass = false
		local vent1 = P_SpawnMobj(mo.x, mo.y, fof.bottomheight, MT_VENT)
		vent1.die = 150
		vent1.scale = FRACUNIT/5
		vent1.flags2 = MF2_SPLAT
		local vent2 = P_SpawnMobj(mo.x, mo.y, fof.topheight, MT_VENT)
		vent2.die = 150
		vent2.scale = FRACUNIT/5
		vent2.flags2 = MF2_SPLAT
		if mo.eflags & MFE_VERTICALFLIP
		mo.player.pflags = $|PF_JUMPED
			vent1.eflags = $ & ~MFE_VERTICALFLIP
			vent1.flags2 = $ & ~MF2_OBJECTFLIP
			vent2.eflags = $|MFE_VERTICALFLIP
			vent2.flags2 = $|MF2_OBJECTFLIP
		else
			vent1.eflags = $|MFE_VERTICALFLIP
			vent1.flags2 = $|MF2_OBJECTFLIP
			vent2.eflags = $ & ~MFE_VERTICALFLIP
			vent2.flags2 = $ & ~MF2_OBJECTFLIP
		end
		S_StartSound(vent, sfx_vent)
		S_StartSound(mo, ventsound[P_RandomRange(1, 3)])
		P_SetObjectMomZ(mo, -10*FRACUNIT)
	end	
  end
end

addHook("PlayerThink", function(p)
  if not p.mo return end
  if (p.mo.skin != "impostor") return end
  if (p.vent != true) return end
  if (p.ventpass != true) return end

  CheckAndpass(p.mo, p.mo.subsector.sector)
end)

addHook("MobjLineCollide", function(mo, line)
  if not mo.player return end
  if (mo.skin != "impostor") return end
   if (mo.player.vent != true) return end
   if (mo.player.ventpass != true) return end

  for _, sec in ipairs({line.frontsector, line.backsector})
    CheckAndpass(mo, sec)
  end
end, MT_PLAYER)

addHook("PlayerThink", function(player)
	if player.mo and player.valid and player.playerstate == PST_LIVE and not (player.powers[pw_carry] == CR_NIGHTSMODE)
	and player.mo.skin == "impostor"
		player.target = P_LookForEnemies(player, false, true)
		player.powers[pw_underwater] = 9999
		player.powers[pw_spacetime] = 9999
		local long
		if player.ventpass == nil
			player.ventpass = true
		end	
		if P_IsObjectOnGround(player.mo)
			player.ventpass = true
		end
		if player.target
			long = R_PointToDist2(player.mo.x, player.mo.y, player.target.x, player.target.y)
		end	
		if player.reportcooldown == nil
			player.reportcooldown = 0
		end
		if player.ventcooldown == nil
			player.ventcooldown = 0
		end
		if player.killcooldown == nil
			player.killcooldown = 0
		end
		if player.vent == nil
			player.vent = false
		end
		if player.venttime == nil
			player.venttime = 10
		end
		if player.delete == nil
			player.delete = 0
		end	
		if player.mo.state != S_PLAY_VENT
			player.mo.spriteyscale = FRACUNIT
			player.mo.spritexscale = FRACUNIT
		end
		if player.vent == true
			player.normalspeed = skins["sonic"].normalspeed
			if (player.mo.eflags & MFE_TOUCHLAVA or player.mo.eflags & MFE_GOOWATER)
				player.pflags = $ & ~PF_THOKKED
				player.vent = false
				player.venttime = 10
				player.normalspeed = skins[player.mo.skin].normalspeed
				player.mo.flags2 = $ & ~MF2_DONTDRAW
				player.pflags = $ & ~(PF_INVIS|PF_THOKKED)
				player.mo.height = skins[player.mo.skin].height
				player.height = skins[player.mo.skin].height
				player.shieldscale = skins[player.mo.skin].shieldscale
				player.charflags = skins[player.mo.skin].flags
				player.mo.flags = $ & ~MF_NOCLIPTHING
			end
			if player.ventpass == false
				player.charflags = skins[player.mo.skin].flags
			else
				player.charflags = $|SF_CANBUSTWALLS
			end
			if player.mo.eflags & MFE_SPRUNG
				P_SetObjectMomZ(player.mo, 10*FRACUNIT, true)
				S_StartSound(player.mo, sfx_sprong)
			end	
			if P_IsObjectOnGround(player.mo)
				if player.mo.eflags & MFE_JUSTHITFLOOR and (player.mo.z <= player.mo.subsector.sector.floorheight or player.mo.z+player.mo.height >= player.mo.subsector.sector.ceilingheight)
					local vent = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_VENT)
					vent.die = 150
					vent.scale = FRACUNIT/5
					vent.flags2 = MF2_SPLAT
					if player.mo.eflags & MFE_VERTICALFLIP
						vent.eflags = $|MFE_VERTICALFLIP
						vent.flags2 = $|MF2_OBJECTFLIP
					else
						vent.eflags = $ & ~MFE_VERTICALFLIP
						vent.flags2 = $ & ~MF2_OBJECTFLIP
					end
					S_StartSound(vent, sfx_vent)
				end
				if player.venttime > 0
					if not (player.mo.eflags & MFE_TOUCHLAVA or player.mo.eflags & MFE_GOOWATER)
						if not (player.powers[pw_sneakers])
							if (leveltime % 20) == 1
								player.venttime = $1 - 1
							end
						else
							if (leveltime % 40) == 1
								player.venttime = $1 - 1
							end
						end	
					end	
					player.mo.flags2 = $|MF2_DONTDRAW
					player.normalspeed = skins["sonic"].normalspeed
					local rxy = P_RandomRange(-10, 10)*FRACUNIT
					if player.speed > 5*FRACUNIT and not (player.mo.eflags & MFE_GOOWATER)
						local ground = P_SpawnMobj(player.mo.x+rxy, player.mo.y+rxy, player.mo.z, MT_MINUSDIRT)
						if not S_SoundPlaying(player.mo, sfx_mindig)
							S_StartSound(player.mo, sfx_mindig)
						end	
						if player.mo.eflags & MFE_VERTICALFLIP
							ground.eflags = $|MFE_VERTICALFLIP
							ground.flags2 = $|MF2_OBJECTFLIP
						else
							ground.eflags = $ & ~MFE_VERTICALFLIP
							ground.flags2 = $ & ~MF2_OBJECTFLIP
						end
					end
					player.charflags = $|SF_CANBUSTWALLS
					player.shieldscale = 0
					player.powers[pw_flashing] = 2
					player.pflags = $|PF_INVIS
					player.mo.height = 1*FRACUNIT
					player.height = 1*FRACUNIT
					player.mo.flags = $|MF_NOCLIPTHING
				end
			else
				player.mo.state = S_PLAY_VENT
				player.mo.spriteyscale = FRACUNIT - FixedMul(sin(player.mo.momz/FRACUNIT*2*ANG1), FRACUNIT/2)
				player.mo.spritexscale = FRACUNIT + FixedMul(sin(player.mo.momz/FRACUNIT*2*ANG1), FRACUNIT/2)
				player.mo.flags2 = $ & ~MF2_DONTDRAW
				player.pflags = $ & ~PF_INVIS
				player.mo.height = skins[player.mo.skin].height
				player.height = skins[player.mo.skin].height
				player.shieldscale = skins[player.mo.skin].shieldscale
				player.mo.flags = $ & ~MF_NOCLIPTHING
			end
			if (player.venttime <= 0 or (player.cmd.buttons & BT_JUMP and player.jump == false)) and not (player.pflags & PF_THOKKED)
			and not (player.mo.eflags & MFE_TOUCHLAVA or player.mo.eflags & MFE_GOOWATER)
				player.vent = false
				player.venttime = 10
				player.normalspeed = skins[player.mo.skin].normalspeed
				player.mo.flags2 = $ & ~MF2_DONTDRAW
				local vent
				if player.mo.eflags & MFE_VERTICALFLIP
					vent = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z-player.mo.height, MT_VENT)
				else
					vent = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_VENT)
				end	
				vent.die = 150
				vent.scale = FRACUNIT/5
				vent.flags2 = MF2_SPLAT
				if player.mo.eflags & MFE_VERTICALFLIP
					vent.eflags = $|MFE_VERTICALFLIP
					vent.flags2 = $|MF2_OBJECTFLIP
				else
					vent.eflags = $ & ~MFE_VERTICALFLIP
					vent.flags2 = $ & ~MF2_OBJECTFLIP
				end
				P_SetObjectMomZ(player.mo, 8*FRACUNIT)
				player.mo.state = S_PLAY_VENT
				S_StartSound(vent, sfx_vent)
				player.powers[pw_flashing] = 15
				player.pflags = $ & ~(PF_INVIS|PF_THOKKED)
				player.mo.height = skins[player.mo.skin].height
				player.height = skins[player.mo.skin].height
				player.shieldscale = skins[player.mo.skin].shieldscale
				player.pflags = $|PF_JUMPED
				player.charflags = skins[player.mo.skin].flags
				player.delete = 5
			end
		end
		if player.cmd.buttons & BT_JUMP
			player.jump = true
		else
			player.jump = false
		end
		if player.mo.state == S_PLAY_VENT
		and player.vent == false
			player.mo.spriteyscale = FRACUNIT + FixedMul(sin(player.mo.momz/FRACUNIT*2*ANG1), FRACUNIT/2)
			player.mo.spritexscale = FRACUNIT - FixedMul(sin(player.mo.momz/FRACUNIT*2*ANG1), FRACUNIT/2)
		end
		if player.delete and player.delete > 0
			player.delete = $ - 1
			player.pflags = $|PF_SPINNING
			if player.delete > 3
				player.mo.flags = $|MF_NOCLIPTHING
			else
				player.mo.flags = $ & ~MF_NOCLIPTHING
			end
		end
		if player.pflags & PF_SPINNING
		and player.mo.state == S_PLAY_VENT
		and player.delete <= 0
			player.pflags = $ & ~PF_SPINNING
			player.mo.flags = $ & ~MF_NOCLIPTHING
		end
		if player.target and long < 500*FRACUNIT
		and player.mo.state != S_PLAY_SUSFACE
			if not (player.target.type == MT_PLAYER)
			and not player.target.player
				if player == displayplayer
					local ghost = P_SpawnGhostMobj(player.target)
					ghost.scale = player.target.scale + FRACUNIT/5
					ghost.spriteyoffset = $1 - 5*FRACUNIT
					ghost.frame = $ & ~(FF_TRANSMASK|FF_TRANS50)
					local gotox = player.target.x+FixedMul(5*FRACUNIT, cos(player.mo.angle))
					local gotoy = player.target.y+FixedMul(5*FRACUNIT, sin(player.mo.angle))
					P_TeleportMove(ghost, gotox, gotoy, player.target.z)
					ghost.colorized = true
					ghost.fuse = 5
					ghost.momx = player.target.momx
					ghost.momy = player.target.momy
					ghost.momz = player.target.momz
					ghost.color = SKINCOLOR_OUTLINE
				end	
			else
				P_SpawnLockOn(player, player.target, S_LOCKON1)
			end
			if player.cmd.buttons & BT_CUSTOM1
				if player.custom1 == false
				and player.reportcooldown <= 0 
					player.target.eject = true
					player.target.eject2 = 150
					//player.mo.color = $ + 1
					player.reportcooldown = REPORTCOOLDOWN
					if player.target.votes < 10
						player.target.votes = $ + 1
					end	
					if not player.target.votesmo
						player.target.votesmo = {}
					end	
					player.target.votesmo[player.target.votes] = player.mo
					if player.target.votes == 1
						S_StartSoundAtVolume(player.target, sfx_report, 225)
					else
						S_StartSound(player.mo, sfx_vote)
					end
				end	
				player.custom1 = true
			else
				player.custom1 = false
			end
			if player.killcooldown <= 0
				if player.cmd.buttons & BT_SPIN
				and player.spin == false
				and player.vent == false
					player.powers[pw_flashing] = 1
					P_TeleportMove(player.mo, player.target.x, player.target.y, player.target.z)
					P_DamageMobj(player.target, player.mo, player.mo)
					S_StartSound(player.mo, sfx_kill)
					if player.target.health > 0
						player.powers[pw_flashing] = 15
					end	
					if P_IsObjectOnGround(player.target)
						if player.pflags & PF_JUMPED
							player.pflags = $ & ~PF_JUMPED
						end
						if player.mo.state == S_PLAY_VENT
							player.mo.state = S_PLAY_STND
						end
					else
						if not (player.pflags & PF_JUMPED)
							player.pflags = $|PF_JUMPED
						end
						player.mo.state = S_PLAY_VENT
					end
					player.mo.momz = 0
					player.killcooldown = MAXKILLCOOLDOWN
					player.pflags = $|PF_FULLSTASIS
					player.target.stabber = player.mo
				end
			end
		end	
		if player.cmd.buttons & BT_SPIN
			player.spin = true
		else
			player.spin = false
		end
		if player.mo.state == S_PLAY_SUSFACE
			player.pflags = $|PF_FULLSTASIS
		end
		if player.reportcooldown > 0
			if not (player.powers[pw_sneakers])
				if (leveltime % 20) == 1
					player.reportcooldown = $1 - 1
				end
			else
				player.reportcooldown = $1 - 1
			end	
		end
		if player.killcooldown > 0
			if not (player.powers[pw_sneakers])
				if (leveltime % 20) == 1
					player.killcooldown = $1 - 1
				end
			else
				player.killcooldown = $1 - 1
			end	
		end
	end
	if player.valid and player.mo.skin == "impostor"
		player.wasTheImpostor = {
			[0] = player.name,
			[1] = player.name.." ",
			[2] = player.name.." w",
			[3] = player.name.." wa",
			[4] = player.name.." was",
			[5] = player.name.." was ",
			[6] = player.name.." was T",
			[7] = player.name.." was Th",
			[8] = player.name.." was The",
			[9] = player.name.." was The ",
			[10] = player.name.." was The I",
			[11] = player.name.." was The Im",
			[12] = player.name.." was The Imp",
			[13] = player.name.." was The Impo",
			[14] = player.name.." was The Impos",
			[15] = player.name.." was The Impost",
			[16] = player.name.." was The Imposto",
			[17] = player.name.." was The Impostor",
			[18] = player.name.." was The Impostor."
		}
		if player.death == nil
			player.death = -1
		end
		if player.deathanim == nil
			player.deathanim = false
		end
		if player.deathanimcd == nil
			player.deathanimcd = 0
		end
		if player.playerstate == PST_DEAD
			if player.death < 18
				if (leveltime%2) == 1
					player.death = $ + 1
					S_StartSound(player.mo, sfx_textj, player)
				end	
			end	
			if player.deathanim == true
				if (leveltime%2) == 1
					player.mo.momz = FRACUNIT
				else
					player.mo.momz = 0
				end
				player.deathanimcd = $ + 1
				if player.deathanimcd >= 15 and player.mo.rollangle < ANGLE_45
					player.mo.rollangle = $ + 5*ANG1+(player.deathanimcd%15)*ANG1
				end
				if player.mo.rollangle >= ANGLE_45
				and player.mo.rollangle != ANGLE_90+(15*ANG1)
					player.mo.rollangle = ANGLE_90+(15*ANG1)
				end
			end
			player.mo.spriteyscale = FRACUNIT
			player.mo.spritexscale = FRACUNIT
			player.deathtext = player.wasTheImpostor[player.death]
			//player.deathtext = string.sub(player.name.." was the Impostor.", 1, player.death)
			//print(player.deathtext)
		else
			player.death = -1
			player.deathtext = nil
		end
	end
end)

freeslot("MT_NOTIMPOSTOR", "S_NOTIMPOSTOR")
freeslot("sfx_amogus")

addHook("MobjThinker", function(mo) //Enemy hook after "reporting" them
	if not mo.valid return end
	if mo.votes == nil
		mo.votes = 0
	end
	if mo.eject == true
		if mo.eject2 > 0
			mo.eject2 = $1 - 1
		end	
		if mo.eject2 >= 100 and mo.votes and mo.votes > 0
			for i = 1, mo.votes
				local vote
				if mo.eflags & MFE_VERTICALFLIP
					vote = P_SpawnMobj(mo.x, mo.y, mo.z-mo.height+(25*FRACUNIT*i), MT_REPORT)
				else
					vote = P_SpawnMobj(mo.x, mo.y, mo.z+mo.height+(25*FRACUNIT*i), MT_REPORT)
				end
				vote.fuse = 2
				vote.skin = mo.votesmo[i].skin
				vote.color = mo.votesmo[i].color
				vote.state = S_REPORT
				vote.scale = FRACUNIT + FRACUNIT/5
				if mo.eflags & MFE_VERTICALFLIP
					vote.eflags = $|MFE_VERTICALFLIP
					vote.flags2 = $|MF2_OBJECTFLIP
				else
					vote.eflags = $ & ~MFE_VERTICALFLIP
					vote.flags2 = $ & ~MF2_OBJECTFLIP
				end
			end	
		end
		if mo.eject2 < 100
			P_SetObjectMomZ(mo, 1*FRACUNIT, true)
			mo.rollangle = $1 + 5*ANG1
			mo.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP|MF_NOGRAVITY
			if mo.eject2 == 99
				local ejecttext = P_SpawnMobj(mo.x, mo.y, mo.floorz+50*FRACUNIT, MT_NOTIMPOSTOR)
				ejecttext.appear = 50
				ejecttext.scale = 0
				ejecttext.fuse = 150
				ejecttext.color = SKINCOLOR_AETHER
				if mo.eflags & MFE_VERTICALFLIP
					ejecttext.eflags = $|MFE_VERTICALFLIP
					ejecttext.flags2 = $|MF2_OBJECTFLIP
				else
					ejecttext.eflags = $ & ~MFE_VERTICALFLIP
					ejecttext.flags2 = $ & ~MF2_OBJECTFLIP
				end
				//ejecttext.state = S_NOTIMPOSTOR
				if not S_SoundPlaying(mo, sfx_textj)
					S_StartSound(mo, sfx_textj)
				end	
				if P_RandomRange(1, 1000) == 1
				and mo.health <= 1
					mo.state = S_AMOGUS
					S_StartSound(mo, sfx_amogus)
					mo.votes[1].state = S_PLAY_SUSFACE
					ejecttext.state = S_LESUSAMOGUS
					ejecttext.color = SKINCOLOR_RED
				else
					S_StartSound(mo, sfx_eject)
				end
			end
		end	
		if mo.eject2 <= 0
			mo.eject = false
			mo.eject2 = 0
			mo.rollangle = 0
			mo.flags = mobjinfo[mo.type].flags
			if mo.votes
				for i = 1, mo.votes
					P_DamageMobj(mo, mo.votesmo[i], mo.votesmo[i])
				end	
			end
			P_SetObjectMomZ(mo, -500*FRACUNIT, false)	
			mo.stabber = nil
			mo.votes = 0
		end
	end
	if mo.die
		if mo.die > 0
			mo.die = $ - 1
			if mo.die <= 50 
				mo.scale = $ - FRACUNIT/20/5
				if mo.die <= 0
					P_KillMobj(mo)
					//mo.appear = 0
					//mo.die = 0
				end
			end
		end
	end
	if mo.valid and mo.appear 
		if mo.appear > 0
			mo.appear = $ - 1
			if mo.appear <= 50 
				if mo.scale < FRACUNIT
					mo.scale = $ + FRACUNIT/20
				end	
				if mo.appear <= 0 or mo.scale > FRACUNIT
					mo.scale = FRACUNIT
					mo.appear = 0
				end
			end
		end
	end
end)

addHook("TouchSpecial", function(mobj, mo)
	if mobj.type == MT_RING and mobj.valid
		if mo.valid
		and mo.skin == "impostor"
		and not (mo.player.powers[pw_carry] == CR_NIGHTSMODE)
			if mo.player.reportcooldown and mo.player.reportcooldown > 0
				mo.player.reportcooldown = $ - 1
			end	
			if mo.player.vent == true
				mo.player.venttime = $ + 1
			end	
			if mo.player.killcooldown and mo.player.killcooldown > 0
				mo.player.killcooldown = $ - 1
			end	
		end
	end
end)

addHook("AbilitySpecial", function(player)
	if player.mo and player.valid and player.playerstate == PST_LIVE and not (player.powers[pw_carry] == CR_NIGHTSMODE)
	and player.mo.skin == "impostor"
		if not (player.pflags & PF_THOKKED)
		and player.vent == false
			player.pflags = $|PF_THOKKED
			player.vent = true
			player.venttime = 10
			player.pflags = $ & ~PF_SPINNING
			if player.mo.state == S_PLAY_VENT
				local ghost = P_SpawnGhostMobj(player.mo)
				ghost.spriteyscale = player.mo.spriteyscale
				ghost.spritexscale = player.mo.spritexscale
			end
		end
	end
end)

addHook("ShouldDamage", function(mo)
	if mo.votes 
		return true
	end
end)

local function Fadeaway(mo)
	if mo.valid
		local ghost = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
		ghost.fuse = 50
		ghost.state = mo.state
		ghost.color = mo.color
		ghost.flags2 = mo.flags2
		ghost.eflags = mo.eflags
	end
end

addHook("MobjDeath", Fadeaway, MT_NOTIMPOSTOR)
addHook("MobjFuse", Fadeaway, MT_NOTIMPOSTOR)

addHook("MobjDeath", function(mo)
	if mo.valid and mo.skin == "impostor"
		S_StartSound(mo, sfx_kill)
		mo.player.deathanim = true
		mo.player.deathanimcd = 0
	end
end, MT_PLAYER)

local function BreakSpikes(mo, spike)
	if mo.valid and spike.valid
	and spike.type == MT_SPIKE
	and mo.type == MT_MINUSDIRT
		if (spike.z >= (mo.z - 16*FRACUNIT)) and (spike.z <= (mo.z + mo.height + 16*FRACUNIT))
			P_KillMobj(spike, mo, mo)
		elseif (spike.flags2 & MF2_OBJECTFLIP)
		and (spike.z <= (mo.z - 16*FRACUNIT)) and (spike.z >= (mo.z + mo.height+ 16*FRACUNIT))
			P_KillMobj(spike, mo, mo)
        end
	end
end	

addHook("MobjMoveCollide", BreakSpikes)
addHook("MobjCollide", BreakSpikes)